# AMA ABR Ladder application
ama_xabrladder application is a command line utility which implements the GStreamer video transcoding pipeline. This Pipeline expects video input from a file. It creates one or more scaled renditions of the input, encodes them and writes the output streams into files. The application auto detects the codec of input video stream. Supported codecs are H264 and H265. They can be fed as elementary stream or MP4 container.
Below is a block diagram showing an ABR ladder transcode with five output streams.
<img src = "./images/application.png" align = "center">

## Usage
<img src = "./images/usage.png" align = "center">

## Example runs
1. Running one ABR ladder on one device
```
ama_xabrladder --devidx 0 --codectype 1 --file <path to file>
```
2. Above pipe with short parameters
```
ama_xabrladder -i 0 --codectype 1 -f <path to file>
```

3. Running one ABR ladder each on two devices
```
ama_xabrladder --devidx 0 --codectype 1 --file <path to file>

ama_xabrladder --devidx 1 --codectype 1 --file <path to file>
```

4. Running four ABR ladder on one device
```
ama_xabrladder --devidx 0 --codectype 1 --file <path to file>

ama_xabrladder --devidx 0 --codectype 1 --file <path to file>

ama_xabrladder --devidx 0 --codectype 1 --file <path to file>

ama_xabrladder --devidx 0 --codectype 1 --file <path to file>
```

